Subject: Re: bug#32127: RFE -- in the way "cp -rl" -- enable 'ln' to do likewise?

From: Bernhard Voelker <[email-masked]>
Date: Mon, 16 Jul 2018 23:14:21 +0200

On 07/14/2018 07:51 PM, L A Walsh wrote:
> Paul Eggert wrote:
>> On 07/12/2018 02:16 AM, L A Walsh wrote:
>>>     I'm asking why does 'ln' bother to tell the user that they are
>>> wrong and do nothing useful?  Why not just go ahead and create a symlink
>>
>> The user didn't ask for a symlink,
> User didn't ask for a physical or hardlink (-P) either.  Just asked
> for a link, kind unspecified.
> 
>> and it sounds unwise for ln to be
>> second-guessing that.
> ---
>   True - should **probably** have given them *SOME* link.  Since
> they didn't specify Physical or Symlink...either would be fine.
> 
> 
>> Sometimes, reporting an error and exiting is a
>> better thing to do.
> ---
> 	Unless they claim to want one or the other (-P or -l), unless
> it is an "undo-able" operation (like one that deletes data), why would
> you guarantee ln doing the wrong thing, rather than having a better than
> 50% chance of doing the right thing?

I disagree here: some people are not that familiar with the differences
between symlinks and hardlinks, okay, but the consequences for using either
type may be quite dramatic later on.  Therefore I think it's better to give
a helping error instead of second-guessing what the user *may* have wanted.
The point is: also an experienced user may sometimes forget to specify
the -s option, and I'm sure they *want* a proper error message.

Have a nice day,
Berny